       PROGRAM CALIB
C*******************************************
C NEW VERSION FROM APRIL 1992 -WITH JUL91 , SOF1
C FROM CDC 1983 WITH 36 POINT GRID TO DUBNA 2002
C MAX DIMENSION -500 
************************************************
	   IMPLICIT REAL*8(A-H,O-Z)
        DIMENSION X(500),Y(500),F(500),W(500)
        DIMENSION A(50)
	   open(8,file='grid.dat')
	
      OPEN(7,FILE='TWOAP2.DAT')
C
C*******Input Data	
        M=400
C***** ****************Begin approximation
      DO 6 I=1,M
       W(I)=1.
6	   READ(8,*) X(I),Y(I),F(I)
        CALL TSTWO(X,Y,W,M,F,A)
        END

C PROGRAM TSTTWO-TEST TWO-DIMENSIONAL ORTHONORMAL POLYNOMIALS
C VERSION DUBNA 2002-2003
C  NEW WRITE- FILE TWOAP
C************************************************
        SUBROUTINE TSTWO(X,Y,W,M,F,A)
C VARIANT WITH SUBR - PRETWO,DEGREE,ORTWO,NUMBER, -1983 JANUARY
   	IMPLICIT REAL*8(A-H,O-Z)
      COMMON /LINKS/ BETA(153),CN(153),ALPHA(3775),
     .              X0,X1,Y0,Y1,INITX(153)
C      COMMON /LINKS/ INITX(153),BETA(153),CN(153),ALPHA(3775),
C     .        X0,X1,Y0,Y1
      DIMENSION X(500),Y(500),W(500),DELTA(500),F(500),FAPPR(500)
      DIMENSION A(50),ERRA(50),POLY(50)
      DIMENSION DL(50)
      DIMENSION THETA(50),DELTA2(500),Z(500)
      LOGICAL IJK				  
C
C   IJK   REGIME SWITCH(AUTOMATIC)\
C                .TRUE. -SEARCH FOR LOPT
C                 .FALSE. -PRINT RESULTS
C
C===============

C
C C    INPUT DATA
C   SHIFT ORIGIN
C   CONTROL PRINT
C
C
C PREPARE RECURRENCE FACTORS
	   WRITE(*,*) M
      NDEG=2
      CALL PRETWO(M,NDEG,X,Y,W,POLY)
      NEND=NUMBER(0,NDEG)
C
C  SET IJK-SWITCH
C  SET  PROPER LIMITS OF LOOP
      IJK=.TRUE.

 75   IF(IJK) GO TO 77
      INIIN=LOPT
      INIEN=LOPT
      GO TO 85
 77   INIIN=1
      INIEN=NEND
C
C CLEAR COEFFICIENTS
C
      DO 20 I=INIIN,INIEN
 20   A(I)=0.0

 85    CONTINUE
      IF(.NOT.IJK) GO TO 303
C
C COMPUTE COEFFICIENTS OF ORTHONORMAL SERIES
C
      DO 30 J=1,M
      CALL ORTTWO(INIEN,X(J),Y(J),POLY)
       DO 30 IDEG=INIIN,INIEN
 30    A(IDEG)=A(IDEG)+F(J)*W(J)*POLY(IDEG)
C

C CLEAR THETA AND FAPPR ARRAYS
C
      DO 150 I=INIIN,INIEN
 150  THETA(I)=.0
      DO 160 I=1,M
      FAPPR(I)=.0

 160  CONTINUE
C
C COMPUTE FIT AND PILE UP THETA(I)
C

 302  DO 200 J=1,M
      CALL ORTTWO(INIEN,X(J),Y(J),POLY)
      DO 200 IDEG=INIIN,INIEN
      FAPPR(J)=FAPPR(J)+A(IDEG)*POLY(IDEG)
      DEL=F(J)-FAPPR(J)
      DELTA(J)=DEL
 200  THETA(IDEG)=THETA(IDEG)+W(J)*DEL**2
      THETC=1.E+38
C
C SELECT THETA MINIMUM

      DO 300 IDEG=INIIN,INIEN
      THETA(IDEG)=SQRT(THETA(IDEG))
      TH=FLOAT(M-IDEG)
      TH=SQRT(TH)
      IF((M-IDEG).NE.0) THETA(IDEG)=THETA(IDEG)/TH
      IF(THETA(IDEG).GE.THETC) GO TO 300
      THETC=THETA(IDEG)
      LOPT=IDEG
  300  CONTINUE

      IF(IJK) GO TO 95
C
C COMPUTE ERRORS OF SERIES COEFFICIENTS
C
 303  DO 350 I=1,LOPT
 350  ERRA(I)=0.
        DO 400 J=1,M
      CALL ORTTWO(LOPT,X(J),Y(J),POLY)
        DO 400 I=1,LOPT
 400      ERRA(I)=ERRA(I)+(DELTA(J)*POLY(I)*W(J))**2

       DO 450 I=1,LOPT
 450    ERRA(I)=SQRT(ERRA(I))
C
C PRINT RESULTS
C
      PRINT 1100
                  WRITE(7,1100)
      CALL DEGREE(LOPT,JI,JIX,JIY)
      PRINT 1110,JI
                   WRITE (7,1110) JI
      PRINT 1120,JIX,JIY
                    WRITE(7,1120)JIX,JIY
      PAUSE
C     PRINT 1130
C      GO TO 121
                     WRITE(7,1132)
 119  PRINT 1132
 121  DO 120 I=1,M
                  WRITE(7,1140) I,X(I),Y(I),W(I),F(I),FAPPR(I),DELTA(I)
 120  PRINT 1140,I,X(I),Y(I),W(I),F(I),FAPPR(I),DELTA(I)
            PRINT 1150,THETC
                       WRITE(7,1150)THETC
      PAUSE
      PRINT 1160
                    WRITE(7,1160)
   	Write(*,1160)
      DO 130 I=1,LOPT
                  WRITE   (7,1170) I, A(I),ERRA(I)
 130  PRINT 1170,I,A(I),ERRA(I)
      GO TO  1000

 95   IF(.NOT.IJK) GO TO 2000
C EXIT SWITCH(IJK)
C
      IJK=.FALSE.
       GO TO 75
 2000 CONTINUE
 1000 RETURN
 1100 FORMAT('ORTHONORMAL APPROXIMATION IN TWO VARIABLES'/
     9'============================================')

 1110 FORMAT(10X,'LAST TERM OVERALL DEGREE\',I3)
 1120 FORMAT(10X,'LEADING TERM STRUCTURE',2I3)
 1130 FORMAT('0N0.',14X,'X',14X,'Y',14X,'W',14X,'XID',10X,
     9      'XIDAP',8X,'XID-XIDAP'/
     9       '==================',
     9       '==================',
     9      '====================')
 1132 FORMAT('0N0.',11X,'X',11X,'Y',11X,'W',11X,'FID',8X,'FAPP',
     96X,'FID-FAPP'/
     9'=================',
     9'==================',
     9'==============================')
 1140 FORMAT(1H,I3,1P6E12.5)
 1150 FORMAT('NORMALIZED CHI-SQUARE ',1PE15.5)
 1160 FORMAT(' I',1X,'A(I)',8X,'ERRA(I)'/)
 1170 FORMAT(I3,1P2E15.5)
      END


	   
      SUBROUTINE PRETWO(M,MAXD,X,Y,W,POLY)
C  PREPARATION OF RECURRENCE FACTORS OF TWO - DIMENSIONAL POLYNOMIALS
C  WHICH ARE ORTHONORMAL OVER A DISCRETE POINT SET
   	IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(M),Y(M),W(M),POLY(50)
      COMMON /LINKS/ BETA(153),CN(153),ALPHA(3775),
     .              X0,X1,Y0,Y1,INITX(153)
C      COMMON /LINKS/ INITX(153),BETA(153),CN(153),ALPHA(3775),
C     .               X0,X1,Y0,Y1
      EQUIVALENCE (AUXIL,A1)
      IRP=5
        PRINT *,'MAXD'
        PRINT *,MAXD
      NUMBMX=NUMBER(0,MAXD)
        PRINT *,'NUMBMX'
        PRINT *,NUMBMX
      JEND=(MAXD-1)*(5*MAXD**2+14*MAXD+6)/6+1
C  COMPUTE VERSUS INPUT/OUTPUT SWITCH
      IRP=MOD(IABS(IRP),8)
      IF (IRP.LE.3) GO TO 900
C  INITIAl LOAD OF ARRAYS WITH  UNPREPARED -LABEL

      DO 10 I=1,153
      INITX(I)=-8000000
10    BETA(I)=-1.0E38
      DO 20 I=1,3775
20    ALPHA(I)=-1.0E38
C  SELECT EXTREMUM VALUES? SUM UP STATISTICAL WEIGHTS
      AUXIL=0.0
      X0=1.0E38
      Y0=1.0E38
      X1=-1.0E38

      Y1=-1.0E38
      DO 30 I=1,M
      IF (X(I).LT.X0) X0=X(I)
      IF(X(I).GT.X1) X1=X(I)
      IF(Y(I).LT.Y0)Y0=Y(I)
      IF(Y(I).GT.Y1)Y1=Y(I)
30    AUXIL=AUXIL+W(I)
C  FIRST POLYNOMIAL PSI(0,0)
      POLY(1)=1.0/SQRT(AUXIL)
      CN(1)=POLY(1)
        write(*,*) cn(1)
C  SCALING FACTORS OF VARIABLES
      AUXIL=X1-X0
      X0=-(X1+X0)/AUXIL
      X1=2.0/AUXIL
      PRINT *,'X1'
      PRINT *,X1
       PAUSE
      AUXIL=Y1-Y0
      Y0=-(Y1+Y0)/AUXIL
      Y1=2.0/AUXIL
C  FILL IN THE ARRAY OF INITIAL INDEXES INITX(I)
      IF(NUMBMX.LT.3) GO TO 800
C**********************************RECONSIDER AT A LATER STAGE ;

      J=1
      JY=1
      INITX(3)=1
      NLIM=NUMBMX-1
        write(*,*)nlim
      DO 40 I=3,NLIM
      N=2*(J-1)+JY
      INITX(I+1)=INITX(I)+N
      CALL DEGREE(I+1,J,JX,JY)
40    CONTINUE
C  RECURRENCE AND NORMALIZING FACTORS FOR PSI(1,0)

C  PILE UP SUMS NEEDED FOR PSI(0,1)
      S1=.0
      S2=.0
      S3=.0
      S4=.0
          DO 60 I=1,M
          XX=X1*X(I)+X0
          YY=Y1*Y(I)+Y0
          A1=XX*W(I)
          A2=YY*W(I)

          S1=S1+A1
          S2=S2+A2
          S3=S3+A1*XX
60        S4=S4+A2*YY
c       write(*,*) 's1'
c       write(*,*) s1
c       write(*,*) 's2'
c       write(*,*) s2
      A1=POLY(1)**2
        write(*,*) 'a1='
        write(*,*)  a1
      BETA(1)=A1*S1
      A2=BETA(1)**2
      S3=SQRT(A1*S3-A2)
c      write(*,*) s3
      CN(2)=1./S3
      IAL=INITX(4)

      ALPHA(IAL)=S3
C  RECURRENCE AND NORMALIZING FACTORS FOR PSI(0,1)
C  PILE UP ADDITIONAL SUMS
      S1=.0
          DO 70 I=1,M
          YY=Y1*Y(I)+Y0
          CALL ORTTWO(2,X(I),Y(I),POLY)
70        S1=S1+YY*W(I)*POLY(2)
          ALPHA(1)=POLY(1)*S1
      BETA(2)=A1*S2

      A2=BETA(2)**2
        as=a1*s4
        write(*,*)AS
        write(*,*)A2
        al2=alpha(1)**2
        write(*,*)al2
        sa2=a1*s4-a2-alpha(1)**2
        IF(SA2.LE.0) SA2=-SA2
        PRINT *,'SA2'
        write(*,*) sa2
          S4=SQRT(SA2)
C         S4=SQRT(A1*S4-A2-ALPHA(1)**2)
          CN(3)=1./S4
          IAL=INITX(6)
          ALPHA(IAL)=S4
C  NONCYCLING PART OF PREPARATION COMPLETED
C
C  BEGIN EXTERNAL CYCLE OF COMPUTING REMAINING FACTORS
      NLIM=NUMBMX-1
      DO 700 N=3,NLIM

      N1=N+1
      CALL DEGREE(N1,J1,JX1,JY1)
C  CLEAR ALPHA LOCATIONS EXCEPT FOR THOSE FILLED IN
          INAL=INITX(N1)-1
          INPOL=NUMBER(J1-2,0)-1
          NC=N-INPOL
          NCA=NC-1
          DO 100 I=1,NCA
          IAL=INAL+I
          IF (ALPHA(IAL).NE.(-1.0E38)) GO TO 90

          ALPHA(IAL)=0.0
          GO TO 100
90        IREADY=IAL
100       CONTINUE
      BETA(N)=0.0
          CN(N1)=0.0
C  COMPUTE THE MN " MD
      IX=J1*(J1+1)/2+1
      IF(IX.EQ.N1) GO TO 150
      MN=NUMBER(JX1,JY1-1)

      MD=NUMBER(JX1,JY1+1)
      GO TO 200
150   MN=NUMBER(JX1-1,JY1)
      MD=NUMBER(JX1+1,JY1)
C  BEGIN INTERMEDIATE CYCLE OF SCALAR PRODUCTS
200           DO 600 I=1,M
              IF(IX.EQ.N1) GO TO 250
               DZETA=Y1*Y(I)+Y0
              GO TO 300
250           DZETA=X1*X(I)+X0
300           CALL ORTTWO(N,X(I),Y(I),POLY)
              A1=DZETA*POLY(MN)*W(I)
              A2=A1*POLY(MN)
              BETA(N)=BETA(N)+A2
              CN(N1)=CN(N1)+DZETA*A2
C  BEGIN INNERMOST CYCLE ON ALPHAS
                   DO 500 J=1,NCA
                   IAL=INAL+J
                   IPOL=INPOL+J
                   IF(IPOL.NE.MN) GO TO 340

                   INPOL=INPOL+1
                   IPOL=INPOL+J
  340              IF(IAL.EQ.IREADY) GO TO 500
350   ALPHA(IAL)=ALPHA(IAL)+A1*POLY(IPOL)
C  INNERMOST CYCLE COMPLETED
500                CONTINUE
C  INTERMEDIATE CYCLE COMPLETED
      INPOL=INPOL-1
600           CONTINUE
C  COMPUTE NORMALIZING FACTOR

      S1=0.0
      DO 650 I=1,NCA
      IAL=INAL+I
650   S1=S1+ALPHA(IAL)**2
      QQQ=CN(N1)-BETA(N)**2-S1
      IF(QQQ.GE.0) GO TO 660
      ESCAPE=QQQ
      PRINT 655, ESCAPE
655   FORMAT(' NEGATIVE SQUARED FACTOR',E20.6)
      QQQ=-QQQ

660   S1=SQRT(QQQ)
      CN(N1)=1./S1
      IF(MD.GT.NUMBMX) GO TO 700
      INAL=INITX(MD)
      NMIN=NUMBER(J1+1,0)
      IDEL=MD-NMIN
      IF(IX.NE.N1) IDEL = IDEL - 2
      IAL=INAL+IDEL
      IF(IAL.LE.3775) ALPHA(IAL)=S1
C  EXTERNAL CYCLE COMPLETED

700   CONTINUE
800   GO TO 910
900     CONTINUE
C     READ(5,*) NUMBMX,JEND,X0,X1,Y0,Y1,POLY(1),
C    &(INITX(I),I=1,NUMBMX),
C    &(BETA(I), I=1,NUMBMX),
C    &(CN(I),   I=1,NUMBMX),
C    &(ALPHA(I),I=1,  JEND)
910   IRP=MOD(IRP,4)
      IF(IRP.LE.1) GOTO 920
      WRITE(7,*) NUMBMX,JEND,X0,X1,Y0,Y1,POLY(1),
     ((INITX(I),I=1,NUMBMX),
     ((BETA(I), I=1,NUMBMX),
     ((CN(I),   I=1,NUMBMX),
     ((ALPHA(I),I=1,  JEND)
920   IRP=MOD(IRP,2)
      IF(IRP.NE.1) GO TO 930
      PRINT 940, NUMBMX,JEND,X0,X1,Y0,Y1,POLY(1)
      PRINT 950, (INITX(I),I=1,NUMBMX)
      PRINT 960, (BETA(I), I=1,NUMBMX)
      PRINT 970, (CN(I),   I=1,NUMBMX)

      PRINT 980, (ALPHA(I),I=1,  JEND)
930   IRP=0
              RETURN
940   FORMAT('  MAXIMUM NUMBER:',I4//
     >' ALPHAS:       ',I4//
     >' X0:           ',0PE20.5/
     >' X1:           ',0PE20.5/
     >' Y0:           ',0PE20.5/
     >' Y1:           ',0PE20.5/
     >' POLY(1):      ',0PE20.5)

950   FORMAT(' INITX'/(10I8))
960   FORMAT(' BETA '/(0P10E8.2))
970   FORMAT(' CN  '/(0P10E8.2))
980   FORMAT(' ALPHA'/(0P10E8.2))
1000  FORMAT(I1)
        END

      SUBROUTINE DEGREE(N,J,JX,JY)
C  RETURNS AT GIVEN ORDINARY NUMBER OF POLYNOMIAL THE FOLLOWING\
C             J  -OVERALL DEGREE OF POLYNOMIAL NO. N
C             JX - DEGREE IN X-VARIABLE

C             JY - DEGREE IN Y-VARIABLE
C OF COURSE, J=JX+JY?  SERIES ORDERED ACCORDING TO WEISSFELD
C  MAXIMUM N=1,2,3,...,(M+1)*(M+2)/2
C  BOTH JX AND JY ALLOWED TO REACH THE MAXIMUM DEGREE M.
   	IMPLICIT REAL*8(A-H,O-Z)
      A2=FLOAT(2*N)
      A1=SQRT(A2-1.75)-.5
      A2=SQRT(A2+.25)-1.5
      J=MAX0(INT(A1+.00001),INT(A2+.00001))
      JY=N-1-(J*(J+1))/2
      JX=J-JY
      RETURN
      END

      INTEGER FUNCTION NUMBER(JX,JY)
C  AT GIVEN X-DEGREE JX AND Y-DEGREE JY RETURNS THE ORDINARY NUMBER
C  OF POLYNOMIAL IN A SERIES ORDERED ACCORDING TO WEISSFELD
	   IMPLICIT REAL*8(A-H,O-Z)
      N=JX+JY
      NUMBER=(N*(N+1))/2+1+JY
      RETURN
      END

      SUBROUTINE ORTTWO(NUMBMX,X,Y,POLY)

C  AT GIVEN VALUES OF X AND Y RETURNS IN POLY-ARRAY THE SPECIFIC VA
C  OF ALL POLYNOMIALS IN AN ORTHONORMAL SERIES NOS 1 TO NUMBMX
   	IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION POLY(NUMBMX)
      COMMON /LINKS/ BETA(153),CN(153),ALPHA(3775),
     .              X0,X1,Y0,Y1,INITX(153)
C      COMMON /LINKS/ INITX(153),BETA(153),CN(153),ALPHA(3775),
C     .        X0,X1,Y0,Y1
C  MAXIMUM OVERALL DEGREE WITH THESE DIMENSIONS\ 16 (SIXTEEN)
C
C  NON-CYCLING SECTION
      IF(NUMBMX.EQ.1) GO TO 300
      XX=X1*X+X0

      YY=Y1*Y+Y0
      POLY(2)=CN(2)*(XX-BETA(1))*POLY(1)
      IF(NUMBMX.EQ.2) GO TO 300
      IAL=INITX(3)
      POLY(3)=CN(3)*((YY-BETA(2))*POLY(1)-ALPHA(IAL)*POLY(2))
      IF(NUMBMX.EQ.3) GO TO 300
C  CYCLING SECTION - OVERALL DEGREE 2 OR MORE
      DO 200 N=4,NUMBMX
      CALL DEGREE(N,J1,JX1,JY1)
      IF((N-1).EQ.(J1*(J1+1)/2)) GO TO 50

      DZETA=YY
      M=NUMBER(JX1,JY1-1)
      GO TO 100
50    DZETA=XX
      M=NUMBER(JX1-1,JY1)
100   INPOL=NUMBER(J1-2,0)-1
      INAL=INITX(N)-1
      NC=N-INPOL-1
      POLY(N)=0.0
      IAL = INAL

      DO 150 I=1,NC
      IPOL=INPOL+I
      IF(IPOL.EQ.M) GO TO 150
      IAL = IAL + 1
      POLY(N)=POLY(N)+ALPHA(IAL)*POLY(IPOL)
150   CONTINUE
      POLY(N)=CN(N)*((DZETA-BETA(N-1))*POLY(M)-POLY(N))
200   CONTINUE
300   RETURN
      END

